; UnNSISPackedPP.nsi
; Written by HobbyScripter <hobbyscripter+fx@gmail.com>
; Licensed under HSPL

; =====
; ¦
; =====
Name "UnNSISPackedPP"
Caption "Firefox PowerPack"
SilentInstall silent
OutFile "..\UnNSISPackedPP.exe"
Icon "${NSISDir}\Contrib\Graphics\Icons\orange-install.ico"
!include "WordFunc.nsh"
  !insertmacro WordReplace

; =====
; ܼƫŧi
; =====
Var "FxVersion"
Var "FxRegKeyPath"
Var "FxDirPath"
Var "ProfileName"
Var "ProfileDir"

; =====
; D{
; =====
Section ""
  MessageBOX MB_YESNO|MB_ICONQUESTION "oӵ{N|w˯SwM FirefoxAzn~ܡH" IDNO EndOfNSIS
  MessageBOX MB_YESNO|MB_ICONQUESTION "YNnϥΪ Profile O $ProfileNameA|G$\r$\n$ProfileDir$\r$\nzn~ܡH" IDNO EndOfNSIS

  Call installPCMAN
  Call installBookmark
  Call installSP
  Call CreateInstallXPIScript
  Call CreateInstallThemeJARScript
  MessageBOX MB_OK|MB_ICONINFORMATION "YN} Firefox Hܦw˵eC"
  ExecWait '"$FxDirPath\firefox.exe" -url "$EXEDir\Source\install.html"'

  MessageBOX MB_OK|MB_ICONINFORMATION "w˵C"
  ; 
  EndOfNSIS:
SectionEnd

Function installPCMAN
  MessageBOX MB_YESNO|MB_ICONQUESTION "znw PCMan Plugin for Firefox ܡH" IDNO EndOfInstallPCMAN
    CopyFiles /SILENT "$EXEDir\PCMANPlugin\pcman.html" "C:\"
    CopyFiles /SILENT "$EXEDir\PCMANPlugin\pcman.png" "C:\"
    CopyFiles /SILENT "$EXEDir\PCMANPlugin\nppcman.dll" "$FxDirPath\Plugins"
    CopyFiles /SILENT "$EXEDir\PCMANPlugin\TelnetProtocol.js" "$FxDirPath\components"

    FileOpen $0 "$FxDirPath\.autoreg" w
    FileClose $0
    
    Delete "$ProfileDir\compreg.dat"
  EndOfInstallPCMAN:
FunctionEnd

Function installBookmark
  MessageBOX MB_YESNO|MB_ICONQUESTION "znw  ܡH" IDNO EndOfInstallBookmark
    CopyFiles "$EXEDir\bookmarks.html" "$ProfileDir"
  EndOfInstallBookmark:
FunctionEnd

Function installSP
  ReadINIStr $R1 "$EXEDir\list.ini" "Basic" "SPCount"
  StrCmp $R1 0 EndOfInstallSP 0

  MessageBOX MB_YESNO|MB_ICONQUESTION "znw jM ܡH" IDNO EndOfInstallSP
    IntOp $2 0 + 1
    IntOp $R1 $R1 + 0
    InstallSPDoLoop:
      IntCmp $2 $R1 0 0 EndOfInstallSP
      ReadINIStr $R2 "$EXEDir\list.ini" "SP$2" "Name"
      MessageBOX MB_YESNO|MB_ICONQUESTION "znw˷jM $R2 ܡH" IDNO +5
        ReadINIStr $R3 "$EXEDir\list.ini" "SP$2" "PathSrc"
        ReadINIStr $R4 "$EXEDir\list.ini" "SP$2" "PathIcon"
        CopyFiles "$EXEDir\$R3" "$FxDirPath\searchplugins"
        CopyFiles "$EXEDir\$R4" "$FxDirPath\searchplugins"
      IntOp $2 $2 + 1
      Goto InstallSPDoLoop

  EndOfInstallSP:
FunctionEnd

Function CreateInstallXPIScript
  FileOpen $9 "$EXEDir\Source\makeXPI.js" w
  ReadINIStr $R1 "$EXEDir\list.ini" "Basic" "XPICount"
  IntOp $2 1 + 0
  CreateInstallXPIScriptDoLoop:
    IntCmp $2 $R1 0 0 CreateInstallXPIScriptDoLoopEnd
    ReadINIStr $R2 "$EXEDir\list.ini" "XPI$2" "Name"
    ReadINIStr $R3 "$EXEDir\list.ini" "XPI$2" "Path"
    ReadINIStr $R4 "$EXEDir\list.ini" "XPI$2" "Desc"
    GetFullPathName $R3 "$EXEDir\$R3"
    ${WordReplace} $R3 "\" "/" "+" $R3
    StrCpy $R3 "file://$R3"
    FileWrite $9 "makeXPIOption('$R2', '$R3', '$R4');$\r$\n"
    IntOp $2 $2 + 1
    Goto CreateInstallXPIScriptDoLoop
  CreateInstallXPIScriptDoLoopEnd:
  FileClose $9
FunctionEnd

Function CreateInstallThemeJARScript
  FileOpen $9 "$EXEDir\Source\makeThemeJAR.js" w
  ReadINIStr $R1 "$EXEDir\list.ini" "Basic" "ThemeJARCount"
  IntOp $2 1 + 0
  CreateInstallThemeJARScriptDoLoop:
    IntCmp $2 $R1 0 0 CreateInstallThemeJARScriptDoLoopEnd
    ReadINIStr $R2 "$EXEDir\list.ini" "ThemeJAR$2" "Name"
    ReadINIStr $R3 "$EXEDir\list.ini" "ThemeJAR$2" "Path"
    ReadINIStr $R4 "$EXEDir\list.ini" "ThemeJAR$2" "Desc"
    GetFullPathName $R3 "$EXEDir\$R3"
    ${WordReplace} $R3 "\" "/" "+" $R3
    StrCpy $R3 "file://$R3"
    FileWrite $9 "makeThemeJAROption('$R2', '$R3', '$R4');$\r$\n"
    IntOp $2 $2 + 1
    Goto CreateInstallThemeJARScriptDoLoop
  CreateInstallThemeJARScriptDoLoopEnd:
  FileClose $9
FunctionEnd

; =====
; lƨ禡
; =====
Function .onInit
  FindWindow $0 "MozillaWindowClass" ""
  IntCmp $0 0 +4
    MessageBOX MB_OK|MB_ICONSTOP "~GzFirefox"
    Abort
    Goto EndOfNSISInit

  ReadRegStr $FxVersion HKLM "Software\Mozilla\Mozilla Firefox" "CurrentVersion"
  StrCmp $FxVersion "" 0 +4
    MessageBOX MB_OK|MB_ICONSTOP "~G䤣Firefox"
    Abort
    Goto EndOfNSISInit

  StrCpy $FxRegKeyPath "Software\Mozilla\Mozilla Firefox\$FxVersion\Main"
  ReadRegStr $FxDirPath HKLM "$FxRegKeyPath" "Install Directory"
  
  IfFileExists "$FxDirPath\firefox.exe" +4
    MessageBOX MB_OK|MB_ICONSTOP "~G䤣Firefox"
    Abort
    Goto EndOfNSISInit

  IntOp $1 0 + 0
  ReadDefaultProfileDirDoLoop:
    ReadINIStr $ProfileName "$APPDATA\Mozilla\Firefox\profiles.ini" "Profile$1" "Name"
    StrCmp $ProfileName "" ReadDefaultProfileDirDoLoopErrorEnd 0 ; S
      ReadINIStr $R2 "$APPDATA\Mozilla\Firefox\profiles.ini" "Profile$1" "Default"
      StrCmp $R2 "1" 0 +4
        ReadINIStr $ProfileDir "$APPDATA\Mozilla\Firefox\profiles.ini" "Profile$1" "Path"
        GetFullPathName $ProfileDir "$APPDATA\Mozilla\Firefox\$ProfileDir"
        Goto ReadDefaultProfileDirDoLoopEnd
      IntOp $1 $1 + 1
      Goto ReadDefaultProfileDirDoLoop
  ReadDefaultProfileDirDoLoopErrorEnd:
  MessageBOX MB_OK|MB_ICONSTOP "~G䤣w] Profile"
  Abort
  Goto EndOfNSISInit
  ReadDefaultProfileDirDoLoopEnd:

  ; 
  EndOfNSISInit:
FunctionEnd